import { useContext } from "react";
import { userContext } from "@ess-ics/ce-ui-common";
import { SnackbarProvider } from "notistack";
import { UserProvider } from "./UserProvider";

function DisplayUserContextValue() {
  const contextValue = useContext(userContext);
  return <pre id="display">{JSON.stringify(contextValue, null, 2)}</pre>;
}

describe("UserProvider", () => {
  context("when logged in", () => {
    beforeEach(() => {
      cy.login();
    });

    it("provides the user", () => {
      cy.mount(
        <SnackbarProvider
          preventDuplicate
          maxSnack={5}
        >
          <UserProvider>
            <DisplayUserContextValue />
          </UserProvider>
        </SnackbarProvider>
      );

      cy.wait("@getUserRoles");
      cy.wait("@infoFromUserName");
      cy.get("#display").contains("John Smith").contains("DeploymentToolAdmin");

      cy.get("@infoFromUserName.all").should("have.length", 1);
    });
  });
});
