import { IconBadge, InternalLink } from "@ess-ics/ce-ui-common";
import { RecordStatusIcon } from "./RecordIcons";

export function RecordBadge({ record, ...rest }) {
  return (
    <IconBadge
      icon={<RecordStatusIcon record={record} />}
      title={record.name}
      subtitle={
        <InternalLink
          to={`/iocs/${record.iocId}`}
          label={`IOC Details, ${record?.iocName}`}
        >
          {record?.iocName}
        </InternalLink>
      }
      {...rest}
    />
  );
}
